=== modified file 'Dash/Apps/RunningApplicationsGrid.qml'
--- Dash/Apps/RunningApplicationsGrid.qml	2013-06-05 22:03:08 +0000
+++ Dash/Apps/RunningApplicationsGrid.qml	2013-07-02 15:43:20 +0000
@@ -19,6 +19,7 @@
 
 ResponsiveFlowView {
     id: root
+    clip: true
 
     signal updateScreenshots
 

=== modified file 'Dash/DashApps.qml'
--- Dash/DashApps.qml	2013-07-01 07:56:46 +0000
+++ Dash/DashApps.qml	2013-07-02 15:43:20 +0000
@@ -56,10 +56,10 @@
     ListModel {
         id: categoryListModel
         // specifies app categories, type of delegate and model used in each category
-        ListElement { category: "Running apps";           component: "RunningApplicationsGrid"; modelName: "RunningApplicationsModel" }
-        ListElement { category: "Frequently used";        component: "ApplicationsFilterGrid";  modelName: "FrequentlyUsedAppsModel" }
-        ListElement { category: "Installed";              component: "ApplicationsFilterGrid";  modelName: "InstalledApplicationsModel" }
-        ListElement { category: "Available for download"; component: "ApplicationsFilterGrid";  modelName: "AppsAvailableForDownloadModel" }
+        ListElement { category: "Running apps";           component: "Apps/RunningApplicationsGrid.qml"; modelName: "RunningApplicationsModel" }
+        ListElement { category: "Frequently used";        component: "Apps/ApplicationsFilterGrid.qml";  modelName: "FrequentlyUsedAppsModel" }
+        ListElement { category: "Installed";              component: "Apps/ApplicationsFilterGrid.qml";  modelName: "InstalledApplicationsModel" }
+        ListElement { category: "Available for download"; component: "Apps/ApplicationsFilterGrid.qml";  modelName: "AppsAvailableForDownloadModel" }
         function getCategory(category1) {
             if (category1 === "Running apps") {
                 return i18n.tr("Running apps");
@@ -95,23 +95,6 @@
         "AppsAvailableForDownloadModel": appsAvailableForDownloadModel,
     }
 
-    /* Workaround for bug: https://bugreports.qt-project.org/browse/QTBUG-28403
-       When using Loader to load external QML file in the list deelgate, the ListView has
-       a bug where it can position the delegate content to overlap the section header
-       of the ListView - a workaround is to use sourceComponent of Loader instead */
-    Component { id: runningApplicationsGrid; RunningApplicationsGrid { clip: true } }
-    Component {
-        id: applicationsFilterGrid;
-        ApplicationsFilterGrid {
-            onClicked: shell.activateApplication(data)
-        }
-    }
-
-    property var componentModels: {
-        "RunningApplicationsGrid": runningApplicationsGrid,
-        "ApplicationsFilterGrid": applicationsFilterGrid,
-    }
-
     ScopeListView {
         id: categoryView
         anchors.fill: parent
@@ -139,7 +122,7 @@
                     left: parent.left
                     right: parent.right
                 }
-                sourceComponent: componentModels[component]
+                source: component
                 onLoaded: {
                     if (modelName == "RunningApplicationsModel") {
                         item.firstModel = mainStageApplicationsModel
@@ -147,7 +130,13 @@
                         item.canEnableTerminationMode =
                             Qt.binding(function() { return isCurrent; })
                     } else {
+                        function activateApplication(index, data) {
+                            shell.activateApplication(data);
+                        }
+
                         item.model = categoryModels[modelName]
+                        item.clicked.connect(activateApplication);
+
                     }
                 }
             }

=== modified file 'Dash/DashHome.qml'
--- Dash/DashHome.qml	2013-07-01 07:56:46 +0000
+++ Dash/DashHome.qml	2013-07-03 09:46:25 +0000
@@ -32,9 +32,9 @@
     ListModel {
         id: categoryListModel
         // specifies page's content categories, type of delegate and model used in each category
-        ListElement { category: "Frequent Apps";         component: "AppsGrid";       modelName: "AppsModel" }
-        ListElement { category: "Recent Music";          component: "MusicGrid";      modelName: "MusicModel" }
-        ListElement { category: "Videos Popular Online"; component: "VideosGrid";     modelName: "VideosModel" }
+        ListElement { category: "Frequent Apps";         component: "Apps/ApplicationsFilterGrid.qml";  modelName: "AppsModel" }
+        ListElement { category: "Recent Music";          component: "Music/MusicFilterGrid.qml";        modelName: "MusicModel" }
+        ListElement { category: "Videos Popular Online"; component: "Video/VideosFilterGrid.qml";       modelName: "VideosModel" }
         function getCategory(category1) {
             if (category1 === "Frequent Apps") {
                 return i18n.tr("Frequent Apps");
@@ -110,26 +110,6 @@
                                   "VideosModel": videosFilter,
                                  }
 
-    /* Workaround for bug: https://bugreports.qt-project.org/browse/QTBUG-28403
-       When using Loader to load external QML file in the list deelgate, the ListView has
-       a bug where it can position the delegate content to overlap the section header
-       of the ListView - a workaround is to use sourceComponent of Loader instead */
-    Component {
-        id: applicationsFilterGrid
-        ApplicationsFilterGrid {
-            objectName: "dashHomeApplicationsGrid"
-            onClicked: shell.activateApplication(data);
-        }
-    }
-
-    Component { id: musicGrid;      MusicFilterGrid {}  }
-    Component { id: videosGrid;     VideosFilterGrid {} }
-    property var componentModels: {
-                "AppsGrid": applicationsFilterGrid,
-                "MusicGrid": musicGrid,
-                "VideosGrid": videosGrid,
-    }
-
     ScopeListView {
         id: listView
         anchors.fill: parent
@@ -145,13 +125,13 @@
 
             Loader {
                 anchors { top: parent.top; left: parent.left; right: parent.right }
-                sourceComponent: componentModels[component]
+                source: component
                 onLoaded: {
                     item.model = categoryModels[modelName]
 
                     //FIXME: workaround for lack of previews for videos in Home scope.
                     //Need to connect to the clicked() signal here and act upon it here instead.
-                    if (component === "VideosGrid") {
+                    if (modelName === "VideosModel") {
                         function playVideo(index, data) {
                             if (data.fileUri) {
                                 shell.activateApplication('/usr/share/applications/mediaplayer-app.desktop', "/usr/share/demo-assets/videos/" + data.fileUri);
@@ -159,6 +139,13 @@
                         }
 
                         item.clicked.connect(playVideo);
+                    } else if (modelName === "AppsModel") {
+                        function activateApplication(index, data) {
+                            shell.activateApplication(data);
+                        }
+
+                        item.objectName = "dashHomeApplicationsGrid";
+                        item.clicked.connect(activateApplication);
                     }
                 }
             }

=== modified file 'Dash/DashMusic.qml'
--- Dash/DashMusic.qml	2013-07-01 07:56:46 +0000
+++ Dash/DashMusic.qml	2013-07-02 15:43:20 +0000
@@ -50,17 +50,10 @@
         }
     }
 
-    /* Workaround for bug: https://bugreports.qt-project.org/browse/QTBUG-28403
-       When using Loader to load external QML file in the list deelgate, the ListView has
-       a bug where it can position the delegate content to overlap the section header
-       of the ListView - a workaround is to use sourceComponent of Loader instead */
-    Component { id: musicCarousel;   MusicCarousel {} }
-    Component { id: musicFilterGrid; MusicFilterGrid {} }
-
     function getRenderer(categoryId) {
         switch (categoryId) {
-            case 1: return musicCarousel
-            default: return musicFilterGrid
+            case 1: return "Music/MusicCarousel.qml"
+            default: return "Music/MusicFilterGrid.qml"
         }
     }
 
@@ -80,7 +73,7 @@
 
             Loader {
                 anchors { top: parent.top; left: parent.left; right: parent.right }
-                sourceComponent: scopeView.getRenderer(base.categoryId)
+                source: scopeView.getRenderer(base.categoryId)
                 onLoaded: {
                     item.model = results
                 }

=== modified file 'Dash/DashVideos.qml'
--- Dash/DashVideos.qml	2013-07-01 07:56:46 +0000
+++ Dash/DashVideos.qml	2013-07-02 15:43:20 +0000
@@ -51,17 +51,10 @@
         }
     }
 
-    /* Workaround for bug: https://bugreports.qt-project.org/browse/QTBUG-28403
-       When using Loader to load external QML file in the list deelgate, the ListView has
-       a bug where it can position the delegate content to overlap the section header
-       of the ListView - a workaround is to use sourceComponent of Loader instead */
-    Component { id: videosFilterGrid; VideosFilterGrid {} }
-    Component { id: videosCarousel;   VideosCarousel {}   }
-
     function getRenderer(categoryId) {
         switch (categoryId) {
-            case 1: return videosCarousel
-            default: return videosFilterGrid
+            case 1: return "Video/VideosCarousel.qml"
+            default: return "Video/VideosFilterGrid.qml"
         }
     }
 
@@ -115,7 +108,7 @@
             Loader {
                 id: loader
                 anchors { top: parent.top; left: parent.left; right: parent.right }
-                sourceComponent: scopeView.getRenderer(base.categoryId)
+                source: scopeView.getRenderer(base.categoryId)
                 onLoaded: {
                     item.model = results
                 }

=== modified file 'Greeter/Infographics.qml'
--- Greeter/Infographics.qml	2013-06-05 22:03:08 +0000
+++ Greeter/Infographics.qml	2013-07-03 16:56:28 +0000
@@ -81,7 +81,7 @@
                     var nextCircle = presentCircles.itemAt(presentCircleCounter++)
                     if (nextCircle !== null) nextCircle.presentCircleGrowAnim.start()
                 }
-                if (presentCircleCounter > infographic.model.currentDay) {
+                if (presentCircleCounter > infographic.model.currentDay && pastCircleCounter >= pastCircles.count) {
                     stop()
                 }
             }

=== modified file 'Launcher/LauncherDelegate.qml'
--- Launcher/LauncherDelegate.qml	2013-06-26 14:21:39 +0000
+++ Launcher/LauncherDelegate.qml	2013-07-02 19:19:46 +0000
@@ -65,7 +65,6 @@
                 onClicked: root.clicked()
                 onCanceled: root.released()
                 preventStealing: false
-                enabled: root.angle < 5
 
                 onPressAndHold: {
                     root.state = "moving"

=== modified file 'Launcher/LauncherPanel.qml'
--- Launcher/LauncherPanel.qml	2013-06-25 13:25:45 +0000
+++ Launcher/LauncherPanel.qml	2013-07-05 09:02:07 +0000
@@ -100,6 +100,7 @@
             height: parent.height - dashItem.height - parent.spacing*2
             ListView {
                 id: launcherListView
+                objectName: "launcherListView"
                 anchors.fill: parent
                 anchors.topMargin: -itemSize
                 anchors.bottomMargin: -itemSize
@@ -116,15 +117,7 @@
                 // The height of the area where icons start getting folded
                 property int foldingAreaHeight: itemSize * 0.75
                 property int itemSize: width
-
-                Component.onCompleted: {
-                    // This is needed because snapping would partially fold
-                    // the first item on initialisation. This can only be
-                    // overridden by mouse interactions - which is what flick()
-                    // simulates. Setting contentY to 0 would not work because
-                    // of this.
-                    flick(0, units.gu(20))
-                }
+                property int clickFlickSpeed: units.gu(60)
 
                 delegate: LauncherDelegate {
                     id: launcherDelegate
@@ -139,7 +132,26 @@
                     maxAngle: 60
 
                     onClicked: {
-                        root.applicationSelected(launcherModel.get(index).desktopFile);
+                        // First/last item do the scrolling at more than 12 degrees
+                        if (index == 0 || index == launcherListView.count -1) {
+                            if (angle > 12) {
+                                launcherListView.flick(0, -launcherListView.clickFlickSpeed);
+                            } else if (angle < -12) {
+                                launcherListView.flick(0, launcherListView.clickFlickSpeed);
+                            } else {
+                                root.applicationSelected(launcherModel.get(index).desktopFile);
+                            }
+                            return;
+                        }
+
+                        // the rest launches apps up to an angle of 30 degrees
+                        if (angle > 30) {
+                            launcherListView.flick(0, -launcherListView.clickFlickSpeed);
+                        } else if (angle < -30) {
+                            launcherListView.flick(0, launcherListView.clickFlickSpeed);
+                        } else {
+                            root.applicationSelected(launcherModel.get(index).desktopFile);
+                        }
                     }
                 }
 
@@ -151,9 +163,9 @@
                         top: parent.top
                         topMargin: launcherListView.topMargin
                     }
-                    height: launcherListView.itemSize
+                    height: launcherListView.itemSize / 2
                     enabled: launcherListView.contentY > -launcherListView.topMargin
-                    onClicked: launcherListView.flick(0, units.gu(40))
+                    onClicked: launcherListView.flick(0, launcherListView.clickFlickSpeed)
                 }
 
                 MouseArea {
@@ -164,9 +176,9 @@
                         bottom: parent.bottom
                         bottomMargin: launcherListView.bottomMargin
                     }
-                    height: launcherListView.itemSize
+                    height: launcherListView.itemSize / 2
                     enabled: launcherListView.contentHeight - launcherListView.height - launcherListView.contentY > -launcherListView.bottomMargin
-                    onClicked: launcherListView.flick(0, -units.gu(40))
+                    onClicked: launcherListView.flick(0, -launcherListView.clickFlickSpeed)
                 }
             }
         }

=== modified file 'Panel/IndicatorsDataModel.qml'
--- Panel/IndicatorsDataModel.qml	2013-07-03 15:15:23 +0000
+++ Panel/IndicatorsDataModel.qml	2013-07-08 11:02:06 +0000
@@ -48,14 +48,14 @@
             'widgetSource' : ApplicationPaths.shellAppDirectory()+'/Panel/Indicators/NetworkIndicatorWidget.qml',
             'pageSource' : ApplicationPaths.shellAppDirectory()+'/Panel/Indicators/NetworkIndicatorPage.qml'
         },
-        'indicator-power' : {
+        'indicator-battery' : {
             'title': 'Battery',
             'description' : '',
             'priority': 40,
             'widgetSource' : ApplicationPaths.shellAppDirectory()+'/Panel/Indicators/DefaultIndicatorWidget.qml',
             'pageSource' : ApplicationPaths.shellAppDirectory()+'/Panel/Indicators/DefaultIndicatorPage.qml'
         },
-        'indicator-datetime' : {
+        'indicator-time' : {
             'title': 'Date and Time',
             'description' : '',
             'priority': 100,

=== modified file 'debian/changelog'
--- debian/changelog	2013-07-02 14:44:34 +0000
+++ debian/changelog	2013-07-08 02:34:23 +0000
@@ -1,9 +1,105 @@
-unity8 (7.81.3-0ubuntu1) UNRELEASED; urgency=low
-
+unity8 (7.81.3+13.10.20130708ubuntu.unity.next-0ubuntu1) saucy; urgency=low
+
+  [ Michael Terry ]
+  * Ensure the past circle animations complete Currently, all the
+    animations stop as soon as the present circles are all visible. This
+    change ensures that the animations run to completion.
+
+  [ Michael Zanetti ]
+  * improve launcher flicking bahavior - fix initial snapping - improve
+    foldingAreas behavior - increase clickFlick speed to flick 4 items.
+
+  [ Albert Astals ]
+  * Remove workarounds for Qt bug 28403 . (LP: #28403)
+
+  [ Ubuntu daily release ]
+  * Automatic snapshot from revision 83 (ubuntu-unity/next)
+
+ -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 08 Jul 2013 02:34:23 +0000
+
+unity8 (7.81.3+13.10.20130704ubuntu.unity.next-0ubuntu1) saucy; urgency=low
+
+  [ Didier Roche ]
   * Clean packaging for entering saucy and following daily release guidelines
   * Automatic snapshot from revision 49 (bootstrap)
 
- -- Didier Roche <didrocks@ubuntu.com>  Wed, 26 Jun 2013 11:01:09 +0200
+  [ Michał Sawicz ]
+  * Fix unity8.pot file.
+  * Support the simplified theming from ubuntu-ui-toolkit.
+  * Use AbstractButtons instead of Button { color: "transparent" } that
+    doesn't work.
+
+  [ Albert Astals ]
+  * ListViewWithPageHeader implementation in C++. (LP: #1171918)
+  * LVWPH: Do not crash on showHeader if we don't have a header .
+  * Fix bug when setting the same model twice to a QLimitProxyModelQML.
+  * Add some const & Saves us some microseconds in copying stuff.
+
+  [ Daniel d'Andrada ]
+  * Make Greeter and Stage use the new DragHandle component. So they no
+    longer use Revealers. Now a directional drag gesture is required to
+    start the animation that brings back a "minimized" application when
+    the dash is on foreground. Besides that, now they have the following
+    feature:  - Action only completes succesfully if you drag through at
+    least half the    screen width or if your swipe is fast enough. The
+    shorter the swipe, the faster it has to be for the action to auto-
+    complete.
+  * DirectionalDragArea: add touchSceneX, touchSceneY, and sceneDistance
+    properties.
+  * DirectionalDragArea: emit draggingChanged() on direct recognition
+    draggingChanged() should be emited when status change from
+    WaitingForTouch directly to Recognized.
+  * update CODING instructions for building & running.
+  * DragHandle: add stretch and hintDisplacement properties.
+  * DragHandle: fix hinting Revision 64 had a bad interaction with
+    revision 66 (that added line was lost in the merge/rebase process).
+    tst_DragHandle::hintingAnimation() points out the problem (fails on
+    line 388).
+  * Make Panel use DragHandles instead of a Revealer - A directional
+    drag gesture is needed reveal the panel when fullscreen. - better
+    logic for deciding when to auto-complete the show/hide animation -
+    hinting animation to close the panel - Tapping on menu bar no longer
+    opens nearest indicator menu - No closing with handle click.
+
+  [ mhall119 ]
+  * Fix build script error from extra blank line. (LP: #1196322)
+
+  [ Nick Dedekind ]
+  * Changed shellImportPath to return a list of paths. Added
+    prependImportPaths and changed appendImportPaths to check for
+    duplicates.
+
+  [ Mirco Müller ]
+  * Added support and tests for expanding snap-decisions with more than
+    2 actions passed in.
+
+  [ Michael Zanetti ]
+  * As requested by design, decreasing wobblyness in the
+    WrongPasswordAnimation.
+  * improve the bzr commit hook - don't run qmltests in here, it takes
+    too long - don't abort commit on failed tests, its too annoying -
+    instead, print a fat warning and backup the commit message to be
+    reused after uncommitting and fixing the tests.
+  * edge hinting tweaks - change edge hinting behavior to only happen on
+    onPressed and immediately snap back - fix edge hinting to not happen
+    if the Greeter is locked .
+
+  [ Michael Terry ]
+  * Fix "Tap to Unlock" text not appearing when in tablet greeter mode
+    with only one user.
+  * Use libusermetrics to provide infographic data.
+  * Delete builddir/ when running "debuild clean".
+
+  [ Pawel Stolowski ]
+  * Bindings for preview and activation requests.
+
+  [ Kevin Gunn ]
+  * update CODING instructions for building & running.
+
+  [ Ubuntu daily release ]
+  * Automatic snapshot from revision 78 (ubuntu-unity/next)
+
+ -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 04 Jul 2013 12:44:19 +0000
 
 unity8 (7.81.3) UNRELEASED; urgency=low
 

=== modified file 'debian/control'
--- debian/control	2013-07-04 14:47:47 +0000
+++ debian/control	2013-07-08 11:03:54 +0000
@@ -4,12 +4,12 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 Build-Depends: cmake,
                debhelper (>= 9),
-               libjson-perl,
                libdee-qt5-dev (>= 3.0),
                libgl1-mesa-dev[!armhf] | libgl-dev[!armhf],
                libgl1-mesa-dri,
                libgles2-mesa-dev[armhf],
                libhud-client2-dev,
+               libjson-perl,
                libnm-glib-dev,
                libnm-util-dev,
                libpulse-dev,
@@ -17,12 +17,13 @@
                libqt5v8-5-private-dev,
                libunity-core-6.0-dev (<< 7.80),
                libunity-dev (>= 7.0.3),
+               libunity-scopes-json-def-phone,
                libusermetricsoutput1-dev,
                libxcb1-dev,
                pkg-config,
-               python3,
                python (>= 2.7),
                python-setuptools,
+               python3,
                qt5-default,
                qtbase5-dev,
                qtbase5-private-dev,
@@ -33,8 +34,7 @@
                qtdeclarative5-test-plugin,
                qtdeclarative5-ubuntu-ui-toolkit-plugin,
                qtdeclarative5-xmllistmodel-plugin,
-               ttf-ubuntu-font-family,
-               libunity-scopes-json-def-phone,
+               ttf-ubuntu-font-family
 Standards-Version: 3.9.4
 Homepage: http://launchpad.net/unity
 # If you aren't a member of ~unity-team but need to upload
@@ -45,17 +45,22 @@
 
 Package: unity8
 Architecture: any
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
-         unity8-private (= ${binary:Version}),
-         qmenumodel-qml,
+Depends: qmenumodel-qml,
          qtdeclarative5-dee-plugin,
          qtdeclarative5-ubuntu-ui-toolkit-plugin,
          qtdeclarative5-unity-notifications-plugin | unity-notifications-impl,
+         qtdeclarative5-xmllistmodel-plugin,
          unity-notifications-impl-1,
-         qtdeclarative5-xmllistmodel-plugin,
          unity8-fake-env | qtubuntu-shell,
-Recommends: ${unity-default-masterscopes},
+         unity8-private (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
+Recommends: indicator-battery,
+            indicator-messages,
+            indicator-network,
+            indicator-sound,
+            indicator-time,
+            ${unity-default-masterscopes}
 Description: Unity 8 shell
  The Unity 8 shell is the primary user interface for Ubuntu devices.
 
@@ -63,8 +68,7 @@
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Unity 8 private libs
  The Unity 8 shell is the primary user interface for Ubuntu devices.
  .
@@ -75,9 +79,8 @@
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
-Provides: qtubuntu-shell,
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Provides: qtubuntu-shell
 Description: Fake environment for running Unity 8 shell
  Provides fake implementations of some QML modules used by Unity 8 shell
  (e.g Ubuntu.Application) so that you can run it in a sandboxed environment.
@@ -88,21 +91,21 @@
          qtdeclarative5-ubuntu-ui-toolkit-plugin | qt-components-ubuntu,
          unity8 (= ${binary:Version}),
          ${misc:Depends},
-         ${shlibs:Depends},
+         ${shlibs:Depends}
 Description: Indicators client test application
  This package contains the client application for indicators used by autopilot
 
 Package: unity8-autopilot
 Architecture: all
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
-         ${python:Depends},
-         indicators-client (>= ${source:Version}),
+Depends: indicators-client (>= ${source:Version}),
          libautopilot-qt,
          libqt5test5,
          libqt5widgets5,
          python-evdev,
          unity8 (>= ${source:Version}),
          unity8-fake-env (>= ${source:Version}),
+         ${misc:Depends},
+         ${python:Depends},
+         ${shlibs:Depends}
 Description: Test package for Unity 8 shell
  Autopilot tests for the unity8 package

=== modified file 'debian/unity8-autopilot.install'
--- debian/unity8-autopilot.install	2013-07-04 14:47:47 +0000
+++ debian/unity8-autopilot.install	2013-07-08 11:03:54 +0000
@@ -1,2 +1,2 @@
+usr/lib/python*/*/indicators_client
 usr/lib/python*/*/unity*
-usr/lib/python*/*/indicators_client

=== modified file 'plugins/Unity/Indicators/Network/qml/PasswordTextField.qml'
--- plugins/Unity/Indicators/Network/qml/PasswordTextField.qml	2013-07-03 14:52:20 +0000
+++ plugins/Unity/Indicators/Network/qml/PasswordTextField.qml	2013-07-05 15:05:28 +0000
@@ -44,7 +44,7 @@
             }
 
             placeholderText: "Password"
-            echoMode: showPassword.checked ? TextInput.Password : TextInput.Normal
+            echoMode: showPassword.checked ? TextInput.Normal : TextInput.Password
         }
 
         Row {

=== removed file 'po/is.po'
--- po/is.po	2013-07-02 07:01:02 +0000
+++ po/is.po	1970-01-01 00:00:00 +0000
@@ -1,220 +0,0 @@
-# Icelandic translation for unity
-# Copyright (c) 2013 Rosetta Contributors and Canonical Ltd 2013
-# This file is distributed under the same license as the unity package.
-# FIRST AUTHOR <EMAIL@ADDRESS>, 2013.
-#
-msgid ""
-msgstr ""
-"Project-Id-Version: unity\n"
-"Report-Msgid-Bugs-To: FULL NAME <EMAIL@ADDRESS>\n"
-"POT-Creation-Date: 2013-06-26 22:58+0200\n"
-"PO-Revision-Date: 2013-07-01 02:39+0000\n"
-"Last-Translator: Andri Thorlacius <Unknown>\n"
-"Language-Team: Icelandic <is@li.org>\n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
-"Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-07-02 07:01+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
-
-#: Applications/applications.js:23
-msgid "Phone"
-msgstr "Sími"
-
-#: Applications/applications.js:29
-msgid "Camera"
-msgstr "Myndavél"
-
-#: Applications/applications.js:35
-msgid "Gallery"
-msgstr "Myndasafn"
-
-#: Applications/applications.js:40
-msgid "Facebook"
-msgstr "Facebook"
-
-#: Applications/applications.js:46
-msgid "Browser"
-msgstr "Vafri"
-
-#: Applications/applications.js:51
-msgid "Twitter"
-msgstr "Twitter"
-
-#: Applications/applications.js:57
-msgid "GMail"
-msgstr "GMail"
-
-#: Applications/applications.js:62
-msgid "Weather"
-msgstr "Veður"
-
-#: Applications/applications.js:68
-msgid "Notepad"
-msgstr "Skrifblokk"
-
-#: Applications/applications.js:74
-msgid "Calendar"
-msgstr "Dagatal"
-
-#: Applications/applications.js:80
-msgid "Media Player"
-msgstr "Margmiðlunarspilari"
-
-#: Applications/applications.js:86
-msgid "Evernote"
-msgstr "Evernote"
-
-#: Applications/applications.js:91
-msgid "Map"
-msgstr "Kort"
-
-#: Applications/applications.js:96
-msgid "Pinterest"
-msgstr "Pinterest"
-
-#: Applications/applications.js:101
-msgid "SoundCloud"
-msgstr "SoundCloud"
-
-#: Applications/applications.js:106
-msgid "Wikipedia"
-msgstr "Wikipedia"
-
-#: Applications/applications.js:111
-msgid "YouTube"
-msgstr "YouTube"
-
-#: Components/PageHeader.qml:300
-msgid "Recent searches"
-msgstr "Nýlegar leitir"
-
-#: Dash/DashApps.qml:65
-msgid "Running apps"
-msgstr "Forrit í gangi"
-
-#: Dash/DashApps.qml:68
-msgid "Frequently used"
-msgstr "Oft notað"
-
-#: Dash/DashApps.qml:71
-msgid "Installed"
-msgstr "Uppsett"
-
-#: Dash/DashApps.qml:74
-msgid "Available for download"
-msgstr "Fáanlegt til niðurhals"
-
-#: Dash/DashApps.qml:178
-msgid "Apps"
-msgstr "Forrit"
-
-#: Dash/DashHome.qml:40
-msgid "Frequent Apps"
-msgstr "Margnotuð Forrit"
-
-#: Dash/DashHome.qml:43
-msgid "Recent Music"
-msgstr "Nýleg Tónlist"
-
-#: Dash/DashHome.qml:46
-msgid "Videos Popular Online"
-msgstr "Vinsæl Myndbönd á Netinu"
-
-#: Dash/DashHome.qml:175
-msgid "Home"
-msgstr "Heim"
-
-#: Dash/DashMusic.qml:27 Dash/DashVideos.qml:28
-msgid "Featured"
-msgstr "Efst á baugi"
-
-#: Dash/DashMusic.qml:28 Dash/DashVideos.qml:29
-msgid "Recent"
-msgstr "Nýlegt"
-
-#: Dash/DashMusic.qml:29 Dash/DashVideos.qml:30
-msgid "New Releases"
-msgstr "Nýjar Útgáfur"
-
-#: Dash/DashMusic.qml:30
-msgid "Top Charting"
-msgstr "Topp Listi"
-
-#: Dash/DashMusic.qml:99
-msgid "Music"
-msgstr "Tónlist"
-
-#: Dash/DashVideos.qml:31
-msgid "Popular Online"
-msgstr "Vinsælt á Netinu"
-
-#: Dash/DashVideos.qml:155
-msgid "Videos"
-msgstr "Myndbönd"
-
-#: Dash/Video/VideoPreview.qml:98
-msgid "Directed by:"
-msgstr "Leikstýrt af:"
-
-#: Dash/Video/VideoPreview.qml:121
-msgid "Starring:"
-msgstr "Meðal leikara eru:"
-
-#: Dash/Video/VideoPreview.qml:144
-msgid "Author:"
-msgstr "Höfundur:"
-
-#: Greeter/Lockscreen.qml:133
-msgid "Emergency call"
-msgstr "Neyðar símtal"
-
-#: Greeter/PassphraseLockscreen.qml:59
-#, qt-format
-msgid "Hello %1"
-msgstr "Hæ %1"
-
-#: Greeter/PassphraseLockscreen.qml:59
-msgid "Hello"
-msgstr "Hæ"
-
-#: Hud/HudParametrizedActionsPage.qml:132
-msgid "Confirm"
-msgstr "Staðfesta"
-
-#: Hud/Hud.qml:61 Hud/Hud.qml:99 Hud/Hud.qml:372
-msgid "Type or say a command"
-msgstr "Skrifaðu eða segðu eitthvað"
-
-#: Hud/Hud.qml:84
-msgid "Loading. Please Wait..."
-msgstr "Hleð. Vinsamlegast Bíðið..."
-
-#: Hud/Hud.qml:89
-msgid "Speak Now..."
-msgstr "Talaðu Núna..."
-
-#: Hud/Hud.qml:94
-msgid "Speaking..."
-msgstr "Tala..."
-
-#: Panel/MenuContent.qml:192
-msgid "Device"
-msgstr "Tæki"
-
-#: Panel/Menus/Overview/FlightModeWidget.qml:42
-msgid "Flight mode"
-msgstr "Flug hamur"
-
-#: Panel/SearchIndicator.qml:26
-msgid "Search"
-msgstr "Leita"
-
-#: plugins/Unity/scope.cpp:268
-msgid "Sorry, there is nothing that matches your search."
-msgstr "Því miður, það var ekkert sem passaði við leitarorðið þitt."
-
-#: Shell.qml:383
-#, qt-format
-msgid "Please enter %1"
-msgstr "Vinsamlegast sláðu inn %1"

=== modified file 'po/sl.po'
--- po/sl.po	2013-06-30 07:12:06 +0000
+++ po/sl.po	2013-07-06 08:44:50 +0000
@@ -8,14 +8,14 @@
 "Project-Id-Version: unity\n"
 "Report-Msgid-Bugs-To: FULL NAME <EMAIL@ADDRESS>\n"
 "POT-Creation-Date: 2013-06-26 22:58+0200\n"
-"PO-Revision-Date: 2013-06-29 10:26+0000\n"
+"PO-Revision-Date: 2013-07-02 12:59+0000\n"
 "Last-Translator: Damir Jerovšek <Unknown>\n"
 "Language-Team: Slovenian <sl@li.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2013-06-30 07:12+0000\n"
-"X-Generator: Launchpad (build 16692)\n"
+"X-Launchpad-Export-Date: 2013-07-06 08:44+0000\n"
+"X-Generator: Launchpad (build 16696)\n"
 
 #: Applications/applications.js:23
 msgid "Phone"
@@ -23,7 +23,7 @@
 
 #: Applications/applications.js:29
 msgid "Camera"
-msgstr "Fotoaparat"
+msgstr ""
 
 #: Applications/applications.js:35
 msgid "Gallery"
@@ -111,7 +111,7 @@
 
 #: Dash/DashHome.qml:40
 msgid "Frequent Apps"
-msgstr ""
+msgstr "Pogosto uporabljani programi"
 
 #: Dash/DashHome.qml:43
 msgid "Recent Music"
@@ -127,7 +127,7 @@
 
 #: Dash/DashMusic.qml:27 Dash/DashVideos.qml:28
 msgid "Featured"
-msgstr ""
+msgstr "Predstavljeno"
 
 #: Dash/DashMusic.qml:28 Dash/DashVideos.qml:29
 msgid "Recent"
@@ -139,7 +139,7 @@
 
 #: Dash/DashMusic.qml:30
 msgid "Top Charting"
-msgstr ""
+msgstr "Najvišje na lestvici"
 
 #: Dash/DashMusic.qml:99
 msgid "Music"
@@ -147,7 +147,7 @@
 
 #: Dash/DashVideos.qml:31
 msgid "Popular Online"
-msgstr ""
+msgstr "Priljubljeno na spletu"
 
 #: Dash/DashVideos.qml:155
 msgid "Videos"
@@ -163,7 +163,7 @@
 
 #: Dash/Video/VideoPreview.qml:144
 msgid "Author:"
-msgstr "Avtor:"
+msgstr ""
 
 #: Greeter/Lockscreen.qml:133
 msgid "Emergency call"
@@ -176,7 +176,7 @@
 
 #: Greeter/PassphraseLockscreen.qml:59
 msgid "Hello"
-msgstr "Pozdravljeni"
+msgstr ""
 
 #: Hud/HudParametrizedActionsPage.qml:132
 msgid "Confirm"
@@ -217,10 +217,4 @@
 #: Shell.qml:383
 #, qt-format
 msgid "Please enter %1"
-msgstr "Vnesite %1"
-
-#~ msgid "People"
-#~ msgstr "Ljudje"
-
-#~ msgid "Home screen"
-#~ msgstr "Domači zaslon"
+msgstr ""

=== modified file 'src/Panel/Indicators/client/indicatorsclient.cpp'
--- src/Panel/Indicators/client/indicatorsclient.cpp	2013-07-04 14:47:47 +0000
+++ src/Panel/Indicators/client/indicatorsclient.cpp	2013-07-05 16:29:58 +0000
@@ -35,6 +35,22 @@
     engine->setImportPathList(importPathList);
 }
 
+/* When you append and import path to the list of import paths it will be the *last*
+   place where Qt will search for QML modules.
+   The usual QQmlEngine::addImportPath() actually prepends the given path.*/
+void appendImportPaths(QQmlEngine *engine, const QStringList &paths)
+{
+    QStringList importPathList = engine->importPathList();
+    Q_FOREACH(const QString& path, paths) {
+        // don't duplicate
+        QStringList::iterator iter = qFind(importPathList.begin(), importPathList.end(), path);
+        if (iter == importPathList.end()) {
+            importPathList.append(path);
+        }
+    }
+    engine->setImportPathList(importPathList);
+}
+
 IndicatorsClient::IndicatorsClient(int &argc, char **argv)
     : QObject(0),
       m_view(0)
@@ -56,6 +72,7 @@
     m_view = new QQuickView;
     m_view->engine()->setBaseUrl(QUrl::fromLocalFile(::shellAppDirectory()+"Panel/Indicators/client/"));
     prependImportPaths(m_view->engine(), ::overrideImportPaths());
+    appendImportPaths(m_view->engine(), ::fallbackImportPaths());
 
     m_view->setSource(QUrl("IndicatorsClient.qml"));
     m_view->setResizeMode(QQuickView::SizeRootObjectToView);

=== modified file 'src/Panel/Indicators/servicefiles/com.canonical.indicator.battery'
--- src/Panel/Indicators/servicefiles/com.canonical.indicator.battery	2013-06-07 12:51:16 +0000
+++ src/Panel/Indicators/servicefiles/com.canonical.indicator.battery	2013-07-08 11:02:06 +0000
@@ -1,5 +1,5 @@
 [Indicator Service]
-Name=indicator-power
+Name=indicator-battery
 ObjectPath=/com/canonical/indicator/battery
 
 [phone]

=== modified file 'src/Panel/Indicators/servicefiles/com.canonical.indicator.time'
--- src/Panel/Indicators/servicefiles/com.canonical.indicator.time	2013-06-07 12:51:16 +0000
+++ src/Panel/Indicators/servicefiles/com.canonical.indicator.time	2013-07-08 11:02:06 +0000
@@ -1,5 +1,5 @@
 [Indicator Service]
-Name=indicator-datetime
+Name=indicator-time
 ObjectPath=/com/canonical/indicator/time
 
 [phone]

=== modified file 'tests/autopilot/indicators_client/emulators/main_window.py'
--- tests/autopilot/indicators_client/emulators/main_window.py	2013-07-02 14:30:10 +0000
+++ tests/autopilot/indicators_client/emulators/main_window.py	2013-07-08 11:17:27 +0000
@@ -24,6 +24,6 @@
         """Get the page stack"""
         return self.app.select_single("PageStack")
 
-    def get_power_menu(self):
-        """Get the power menu from the list"""
-        return self.app.select_single("BasicMenuItem", objectName="indicator-power");
+    def get_battery_menu(self):
+        """Get the battery menu from the list"""
+        return self.app.select_single("BasicMenuItem", objectName="indicator-battery");

=== renamed file 'tests/autopilot/indicators_client/tests/test_power.py' => 'tests/autopilot/indicators_client/tests/test_battery.py'
--- tests/autopilot/indicators_client/tests/test_power.py	2013-07-02 14:30:10 +0000
+++ tests/autopilot/indicators_client/tests/test_battery.py	2013-07-08 11:17:27 +0000
@@ -21,8 +21,8 @@
 
         # This opens the messaging menu so you don't have to do that in
         # every test case
-        power = self.main_window.get_power_menu()
-        self.pointing_device.move_to_object(power)
+        battery_menu = self.main_window.get_battery_menu()
+        self.pointing_device.move_to_object(battery_menu)
         self.pointing_device.click()
 
         self.page = self.app.select_single("IndicatorsPage");

=== modified file 'tests/qmltests/Launcher/tst_Launcher.qml'
--- tests/qmltests/Launcher/tst_Launcher.qml	2013-06-28 16:35:24 +0000
+++ tests/qmltests/Launcher/tst_Launcher.qml	2013-07-05 09:02:07 +0000
@@ -23,20 +23,21 @@
 /* Nothing is shown at first. If you drag from left edge you will bring up the
    launcher. */
 Item {
+    id: root
     width: units.gu(50)
-    height: units.gu(81)
+    height: units.gu(55)
 
     Launcher {
         id: launcher
         x: 0
         y: 0
         width: units.gu(40)
-        height: units.gu(81)
+        height: parent.height
 
-        property string latestApplicationSelected
+        property string lastSelectedApplication
 
         onLauncherApplicationSelected: {
-            latestApplicationSelected = desktopFile
+            lastSelectedApplication = desktopFile
         }
 
         property int dashItemSelected_count: 0
@@ -58,9 +59,33 @@
     }
 
     UT.UnityTestCase {
+        id: revealer
+
+        function dragLauncherIntoView() {
+            var startX = launcher.dragAreaWidth/2;
+            var startY = launcher.height/2;
+            touchFlick(launcher,
+                       startX, startY,
+                       startX+units.gu(8), startY);
+
+            var panel = findChild(launcher, "launcherPanel");
+            verify(panel != undefined);
+
+            // wait until it gets fully extended
+            tryCompare(panel, "x", 0);
+            tryCompare(launcher, "state", "visible");
+        }
+
+        function waitUntilLauncherDisappears() {
+            var panel = findChild(launcher, "launcherPanel");
+            tryCompare(panel, "x", -panel.width, 1000);
+        }
+    }
+
+    UT.UnityTestCase {
         id: testCase
         name: "Launcher"
-        when: windowShown
+        when: windowShown && initTestCase.completed
 
         // Drag from the left edge of the screen rightwards and check that the launcher
         // appears (as if being dragged by the finger/pointer)
@@ -71,7 +96,7 @@
             // it starts out hidden just left of the left launcher edge
             compare(panel.x, -panel.width)
 
-            dragLauncherIntoView()
+            revealer.dragLauncherIntoView()
 
             // tapping on the center of the screen should dismiss the launcher
             mouseClick(launcher, launcher.width/2, launcher.height/2)
@@ -85,20 +110,25 @@
            corresponding desktop file. E.g. clicking on phone icon should yield
            launcherApplicationSelected("[...]phone-app.desktop") */
         function test_clickingOnAppIconCausesSignalEmission() {
-            launcher.latestApplicationSelected = ""
-
-            dragLauncherIntoView()
+            launcher.lastSelectedApplication = ""
+
+            revealer.dragLauncherIntoView()
+
+            var listView = findChild(launcher, "launcherListView");
+            listView.flick(0, units.gu(500));
+            tryCompare(listView, "flicking", false);
 
             var appIcon = findChild(launcher, "launcherDelegate0")
+
             verify(appIcon != undefined)
 
             mouseClick(appIcon, appIcon.width/2, appIcon.height/2)
 
-            tryCompare(launcher, "latestApplicationSelected",
+            tryCompare(launcher, "lastSelectedApplication",
                        "/usr/share/applications/phone-app.desktop")
 
             // Tapping on an application icon also dismisses the launcher
-            waitUntilLauncherDisappears()
+            revealer.waitUntilLauncherDisappears()
         }
 
         /* If I click on the dash icon on the launcher
@@ -106,7 +136,7 @@
         function test_clickingOnDashIconCausesSignalEmission() {
             launcher.dashItemSelected_count = 0
 
-            dragLauncherIntoView()
+            revealer.dragLauncherIntoView()
 
             var dashIcon = findChild(launcher, "dashItem")
             verify(dashIcon != undefined)
@@ -116,29 +146,8 @@
             tryCompare(launcher, "dashItemSelected_count", 1)
 
             // Tapping on the dash icon also dismisses the launcher
-            waitUntilLauncherDisappears()
-        }
-
-        function dragLauncherIntoView() {
-            var startX = launcher.dragAreaWidth/2
-            var startY = launcher.height/2
-            touchFlick(launcher,
-                       startX, startY,
-                       startX+units.gu(8), startY)
-
-            var panel = findChild(launcher, "launcherPanel")
-            verify(panel != undefined)
-
-            // wait until it gets fully extended
-            tryCompare(panel, "x", 0)
-            tryCompare(launcher, "state", "visible")
-        }
-
-        function waitUntilLauncherDisappears() {
-            var panel = findChild(launcher, "launcherPanel")
-            tryCompare(panel, "x", -panel.width, 1000)
-        }
-
+            revealer.waitUntilLauncherDisappears()
+        }
 
         function test_teaseLauncher_data() {
             return [
@@ -164,7 +173,78 @@
                 wait(100)
                 compare(launcher.maxPanelX, -launcher.panelWidth, "Launcher moved even if it shouldn't")
             }
-            waitUntilLauncherDisappears();
-        }
+            revealer.waitUntilLauncherDisappears();
+            launcher.available = true;
+        }
+    }
+
+    UT.UnityTestCase {
+        id: clickFlickTestCase
+        when: windowShown && testCase.completed
+
+        function test_clickFlick_data() {
+            var listView = findChild(launcher, "launcherListView");
+            return [
+                {tag: "unfolded top", flickSpeed: units.gu(200), clickY: listView.topMargin + units.gu(2), expectFlick: false},
+                {tag: "folded top", flickSpeed: -units.gu(200), clickY: listView.topMargin + units.gu(2), expectFlick: true},
+                {tag: "unfolded bottom", flickSpeed: -units.gu(200), clickY: listView.height - listView.topMargin - units.gu(1), expectFlick: false},
+                {tag: "folded bottom", flickSpeed: units.gu(200), clickY: listView.height - listView.topMargin - units.gu(1), expectFlick: true},
+            ];
+        }
+
+        function test_clickFlick(data) {
+            launcher.lastSelectedApplication = "";
+            revealer.dragLauncherIntoView();
+            var listView = findChild(launcher, "launcherListView");
+
+            listView.flick(0, data.flickSpeed);
+            tryCompare(listView, "flicking", false);
+
+            var oldY = listView.contentY;
+
+            mouseClick(listView, listView.width / 2, data.clickY);
+            tryCompare(listView, "flicking", false);
+
+            if (data.expectFlick) {
+                verify(listView.contentY != oldY);
+                compare(launcher.lastSelectedApplication, "", "Launcher app clicked signal emitted even though it should only flick");
+            } else {
+                verify(launcher.lastSelectedApplication != "");
+                compare(listView.contentY, oldY, "Launcher was flicked even though it should only launch an app");
+            }
+
+            // Restore position on top
+            listView.flick(0, units.gu(200));
+            tryCompare(listView, "flicking", false)
+            // Click somewhere in the empty space to make it hide in case it isn't
+            mouseClick(launcher, launcher.width - units.gu(1), units.gu(1));
+            revealer.waitUntilLauncherDisappears();
+        }
+    }
+
+    UT.UnityTestCase {
+        id: initTestCase
+        name: "LauncherInit"
+        when: windowShown
+
+        /*
+         * FIXME: There is a bug in ListView which makes it snap to an item
+         * instead of the edge at startup. Enable this test once our patch for
+         * ListView has landed upstream.
+         * https://bugreports.qt-project.org/browse/QTBUG-32251
+
+        function test_initFirstUnfolded() {
+
+            // Make sure noone changed the height of the window. The issue this test case
+            // is verifying only happens on certain heights of the Launcher
+            compare(root.height, units.gu(55));
+
+            var listView = findChild(launcher, "launcherListView");
+            compare(listView.contentY, -listView.topMargin, "Launcher did not start up with first item unfolded");
+
+            // Now do check that snapping is in fact enabled
+            compare(listView.snapMode, ListView.SnapToItem, "Snapping is not enabled");
+        }
+        */
     }
 }

